package bg.bas.dcl.general;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.htmlparser.Node;
import org.htmlparser.filters.HasAttributeFilter;
import org.htmlparser.util.NodeList;
import org.jsoup.Jsoup;
import org.jsoup.examples.HtmlToPlainText;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;


import bg.bas.dcl.general.FileHandler;
import bg.bas.dcl.general.InitialParametersReader;

public class JsoupExtractor {
	
	// parameters defining URLs, types of elements, etc.
	// elements are pairs of param. name and a list of param. values
	// usually read from file
	public HashMap<String, ArrayList<String>> parameters = 
			new HashMap<String, ArrayList<String>>();

	public ArrayList<HashMap<String,String>> tree = new  ArrayList<HashMap<String,String>>();

	public JsoupExtractor(){


	}
	
	
	public void process(String initialDir){
		
		try{
			FileHandler fh = new FileHandler();
			List<File> list = fh.getFileListing(new File(initialDir));
	        
			
			for (File f : list){
			
				if (!f.isFile()) continue;
				if (!f.getName().endsWith(".html")
						&& !f.getName().endsWith("htm")) continue;
				
				System.out.println(f.getAbsolutePath());
				String outfilename = f.getAbsolutePath()
						.replace(parameters.get("output-folder-original").get(0), 
								parameters.get("output-folder-processed").get(0))
								+".xml";
				extractInformation(f.getAbsolutePath(),outfilename);
				
				
			}
			
			
			
			/**
			System.out.println("File saved... "+ outfilename + FileHandler.NL
					+ "Please press enter.");
			*/
	
			// waits for input before continuing 
			// to make it easier to follow the program
	//		confirm = new BufferedReader(new InputStreamReader(System.in)).readLine();

		} catch(Exception e){
			e.printStackTrace();
		}

	}
	
	public void extractInformation(String filename, String outfile) throws Exception{
		
		if (filename.endsWith("~")) return;
		
//		Text text = new Text();
		
        Document doc = Jsoup.parse(new File(filename), "UTF-8");
        
        HtmlToPlainText formatter = new HtmlToPlainText();
        
        HashMap<String, String> elementHtml = new HashMap<String, String>();
        
        for (int i = 0; i<tree.size(); i++) {
        	
        	HashMap<String,String> node = tree.get(i);
        	
			if (node.containsKey("finished") && node.get("finished").equals("true")) continue;

        	Document tempDoc = doc;
        	        	
        	// special node elements 'name' and 'parent'
        	// derived from metadata-name
        	
        	if (node.containsKey("html-element-nestedin")){

        		tempDoc = Jsoup.parse(
        				elementHtml
        				.get(node.get("html-element-nestedin")));
        	}
  
        	
      	
        	// for title, source,

        	if (node.containsKey("type") && !node.get("type").equals("null")) {
        		if (node.get("type").equals("attribute")) {
//                	text.setAttribute(node.get("name"),
 //               			getElementValue(tempDoc, node));
        		} 
        		if (node.get("type").equals("element")) {
        			
//                	text.addElements(getElements(tempDoc, node, i+1));
 
        		} 
        	}
        	
         	
        	elementHtml.put(node.get("name"), tempDoc.html());
        }
        
        FileHandler.makeParent(outfile, "/");
   		Writer out = new OutputStreamWriter(
				new FileOutputStream(outfile),
        		parameters.get("output-encoding").get(0));

//   		out.write(text.getXML());
   		out.flush();
   		
   		out.close();
        
	}
		
	public void extractMetadata(String filename) throws Exception{
		
		
	}
	
	public void extractRawText(String filename, String inDir, String outDir) throws Exception{
		
		if (filename.endsWith("~")) return;
		
		System.out.println("0:" +filename);

        
		HTMLParser parser = new HTMLParser(filename);
		
		
		// finds elements in the html code which have a particular
		// attribute with a particular value
		// <div id="mw-content-text" lang="bg" dir="ltr" class="mw-content-ltr">
		
		HasAttributeFilter ncf = new HasAttributeFilter(
				"id", "mw-content-text");
		
		NodeList list1 = parser.extractAllNodesThatMatch(ncf);
		
		String plainText = "";
		
    	for (int j = 0; j < list1.size (); j++) {
	    	Node n1 = list1.elementAt(j);
		
	    	plainText = n1.toPlainTextString();
	    	break;
    	}

        String newfilename = filename
        		.replace(inDir, outDir)
        		.replace(".html", ".txt");
        fh.makeParent(newfilename, "/");
        
   		Writer out = new OutputStreamWriter(
				new FileOutputStream(newfilename),
        		parameters.get("output-encoding").get(0));
   		
   		out.write(plainText);
   		
   		out.flush();
   		out.close();


        /**
        for (HashMap<String,String> map : tree){
        	        	
        	if (map.containsKey("verify-element-nestedin")){
        		
        	}
        	
        	if (map.get("name").equals("title")) {
        		text.setAttribute("title",getElementValue(doc, map));
        	}
        	if (map.get("name").equals("source")) {
        		text.setAttribute("source",getElementValue(doc, map));
        	}
        	if (map.get("name").equals("postlist")) {
        		text.setAttribute("html",getElementValue(doc, map));
        	}
        	
        	if (map.get("name").equals("user")) {
//        		ArrayList<String> names = text.setHtml(getElementValue(doc, map));
        	}
        	
        }
       	*/
		
	}
	
	FileHandler fh = new FileHandler();
	
	public void processDir(String inDir, String outDir){
		
		
		try{
		List<File> list = fh.getFileListing(new File(inDir));
		
		for (File f : list){
			if (!f.isFile()) continue;
			extractRawText(f.getAbsolutePath(), inDir, outDir);
		}
		
			
		} catch(Exception e){
			e.printStackTrace();
		}
		
	}
		
	public String getElementValue(Document doc, HashMap<String,String> node){
		String res = "";
		
		if (node.containsKey("html-element-name") 
				&& !node.get("html-element-name").equals("")){
			
			
			Elements elements = doc.select(node.get("html-element-name"));
			
			for (Element el : elements) {
				
				
				if (node.containsKey("html-element-attribute") 
						&& !node.get("html-element-attribute").equals("")
						&& node.containsKey("html-element-value")){
					
					Elements elist = el.getElementsByAttributeValue(
							node.get("html-element-attribute"),
							node.get("html-element-value"));
					
					if (elist.size()>0){
						
						if (node.containsKey("extract-element-value-type")){
								if (node.get("extract-element-value-type")
										.equals("text")){
									return elist.get(0).ownText();
								}
								if (node.get("extract-element-value-type")
										.equals("attribute")
										&& node.containsKey("extract-element-attribute")){
									return elist.get(0).attr(node.get("extract-element-attribute"));
								}
								if (node.get("extract-element-value-type")
										.equals("full")){
									return elist.get(0).html();
								}
							
						}
						
					}
				}
				
			}
			
		}

		
		return res;
	}

	/**
	public ArrayList<Post> getElements(Document doc, HashMap<String,String> node, int treeindex){
		ArrayList<Post> res = new ArrayList<Post>();
				
		ArrayList<HashMap<String,String>> children = new ArrayList<HashMap<String,String>>();
		
		HashMap<String,Elements> lists = new HashMap<String,Elements>();

        HashMap<String, String> elementHtml = new HashMap<String, String>();

		for (HashMap<String,String> n : tree) {
			
			System.out.println("0: "+node.get("name")+"\t"+n.get("name"));

			
        	Document tempDoc = doc;
        	
        	// special node elements 'name' and 'parent'
        	// derived from metadata-name
        	
        	if (node.containsKey("html-element-nestedin")){

        		tempDoc = Jsoup.parse(
        				elementHtml
        				.get(node.get("html-element-nestedin")));
        	}
  
        	
			
			if (n.containsKey("parent") 
					&& n.get("parent")
						.equals(node.get("name"))){
				children.add(n);
				
				// to avoid processing as arguments of the root 
				// but only of elements of the array (of posts)
				n.put("finished", "true");
				
				if (n.containsKey("html-element-name") 
						&& !n.get("html-element-name").equals("")){
					
					System.out.println(n.get("name")+"\t"+n.get("html-element-name"));
					Elements elements = doc.select(n.get("html-element-name"));
					
					
					for (int k = 0; k < elements.size(); k++) {
						Element e = elements.get(k);
						
						if(n.containsKey("html-element-attribute") 
								&& !n.get("html-element-attribute").equals("")
								&& n.containsKey("html-element-value") 
								&& !n.get("html-element-value").equals("")){
							
							if (e.hasAttr(n.get("html-element-attribute"))
									&& e.attr(n.get("html-element-attribute"))
									   .equals(n.get("html-element-value"))){
																
								System.out.println("ELEMENT " 
										+ n.get("html-element-attribute")
										+ "\t"
										+ n.get("html-element-value"));
							} else if (n.containsKey("html-element-type")
									    && n.get("html-element-type").equals("contains")
										&& e.attr(n.get("html-element-attribute"))
										   .contains(n.get("html-element-value"))){
					        	
							} else {
								
								elements.remove(k);
								k--;
							}
						} 
								
					}

					lists.put(n.get("name"), elements);
				}
			}
		}
		
		Elements texts = lists.get("text");
		
		
		for (int i=0; i< texts.size(); i++) {
		
			Post post = new Post();
			post.setAttribute("text", texts.get(i).ownText());
			
			System.out.println("lists"); 

			for (String key : lists.keySet()) {
				
				System.out.println("list " + key + "\t" + lists.get(key).size()); 

				
				if (key.equals("text")) continue;
				
				Elements list = lists.get(key);

				if (list.size() == texts.size()) {
					
					System.out.println("EQUAL " + key + "\t" + 
								lists.get(key).size()); 

					HashMap<String,String> nn = new HashMap<String,String>();
					for (HashMap<String,String> nnn : tree){
						if (nnn.get("name").equals(key)) {
							nn = nnn;
							break;
						}
					}
					
					System.out.println("Value "+key+" "+list.get(i).text());
					post.setAttribute(key, list.get(i).text());

				}
			}
			
			res.add(post);
		
		}
		
		return res;
	}

	
	public void processFile(String filename, String outfile) throws Exception{
		
		if (filename.endsWith("~")) return;
		
		Text text = new Text();
		
        Document doc = Jsoup.parse(new File(filename), "UTF-8");
        
        HashMap<String, String> elementHtml = new HashMap<String, String>();
        
        for (int i = 0; i<tree.size(); i++) {
        	
        	HashMap<String,String> node = tree.get(i);
        	
			if (node.containsKey("finished") && node.get("finished").equals("true")) continue;

        	Document tempDoc = doc;
        	        	
        	// special node elements 'name' and 'parent'
        	// derived from metadata-name
        	
        	if (node.containsKey("html-element-nestedin")){

        		tempDoc = Jsoup.parse(
        				elementHtml
        				.get(node.get("html-element-nestedin")));
        	}        	
      	
        	// for title, source,

        	if (node.containsKey("type")
        			&& !node.get("type").equals("null")) {
        	
        		
        		if (node.get("type").equals("attribute")) {
                	text.setAttribute(node.get("name"),
                			getElementValue(tempDoc, node));
        		} 
        		if (node.get("type").equals("content")) {
                	text.setContent(getElementValue(tempDoc, node));
        		} 
       		if (node.get("type").equals("element")) {
        			
                	text.addElements(getElements(tempDoc, node, i+1));
 
        		} 
        	}
        	
         	elementHtml.put(node.get("name"), tempDoc.html());
        	
        }
        
        FileHandler.makeParent(outfile, "/");
   		Writer out = new OutputStreamWriter(
				new FileOutputStream(outfile),
        		parameters.get("output-encoding").get(0));

   		out.write(text.getXML());
   		out.flush();
   		
   		out.close();
        
	}
*/

}
