package bg.bas.dcl.general;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.commons.lang3.StringEscapeUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.Token;
import bg.bas.dcl.monolingual.bg.TextProcessor;
import bg.bas.dcl.monolingual.en.TextProcessorEn;

public class TaggedToXMLConverter {
	
	public int senCtr = 0;
	public int parCtr = 0;
	

	public TaggedToXMLConverter(){
		
	}
	
	public String getTokenXML(Token t){
		
		String result = "";

		
		result += "<word";
		
		result += " w=\"" + StringEscapeUtils.escapeXml(t.token) + "\" ";
		result += " l=\"" + StringEscapeUtils.escapeXml(t.lemma) + "\" ";
		result += " pos=\"" + StringEscapeUtils.escapeXml(t.posTag) + "\" ";
		result += " cl=\"" + StringEscapeUtils.escapeXml(t.clauseID) + "\" ";

		if(!t.mwe_p.equals("")) result += " p=\"" + StringEscapeUtils.escapeXml(t.mwe_p) + "\" ";
		if(!t.relation.equals("")) result += " m=\"" + StringEscapeUtils.escapeXml(t.relation) + "\" ";
		if(!t.cl2.equals("")) result += " cl2=\"" + StringEscapeUtils.escapeXml(t.cl2) + "\" ";
		if(!t.cl_al.equals("")) result += " cl_al=\"" + StringEscapeUtils.escapeXml(t.cl_al) + "\" ";

//		result += " wn=\"" + "" + "\" ";
//		result += " mwe=\"" + "" + "\" ";
		
		result += "/>\n";
		
		return result;
		
	}
	
	public String getSentenceXML(ArrayList<Token> sent, int id){
		
		String result = "";

		result += "<S id=\""+id+"\">";
		
		for (int i = 0; i < sent.size(); i++){
		
			result += getTokenXML(sent.get(i));
		
		}
		
		result += "</S>\n";
		
		return result;
		
	}


	public String processEncodedXML(String word){
		
		String result = StringEscapeUtils.escapeXml(word);
		
//		System.out.println(word);
		
		return result;
	}
	
	public String processDecodedXML(String word){
		
		String result = StringEscapeUtils.unescapeXml(word);
		
//		System.out.println(word);
		
		return result;
	}
	

}
