package bg.bas.dcl.monolingual.bg;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URI;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import org.apache.http.HeaderElement;
import org.apache.http.HeaderElementIterator;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.AbstractHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicHeaderElementIterator;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import bg.bas.dcl.general.FileHandler;


import opennlp.tools.sentdetect.SentenceDetectorME;
import opennlp.tools.sentdetect.SentenceModel;
import opennlp.tools.util.InvalidFormatException;
import opennlp.tools.tokenize.*;

	

public class TextProcessor {
	
	String resourcePathSent = "/home/ivelina/DCLTools/trunk/resources/en-sent.bin";
	String resourcePathTokens = "/home/ivelina/DCLTools/trunk/resources/en-token.bin";
	InputStream modelSent = null;
	SentenceModel modelS = null;
	SentenceDetectorME sentenceDetector = null;
	SimpleTokenizer tokenDetector = null;
	
	public final static String[] services = {"tokenizer", "tagger", "lematizer"};
	public final static int Tokenizer = 0, Tagger = 1, Lematizer = 2;
	public final static String token = "619e68bffedc7243fe6b82822987432d";

	public TextProcessor(){
		try {
			modelSent = new FileInputStream(resourcePathSent);
			modelS = new SentenceModel(modelSent);			
			sentenceDetector = new SentenceDetectorME(modelS);
			
			tokenDetector = new SimpleTokenizer();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	public TextProcessor(String resourcePathSent){
		this.resourcePathSent = resourcePathSent;
		
		try {
			modelSent = new FileInputStream(resourcePathSent);
			modelS = new SentenceModel(modelSent);			
			sentenceDetector = new SentenceDetectorME(modelS);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	public String[] splitToSentences(String text){

		    String sentences[] = sentenceDetector.sentDetect(text);	    	      
		    return sentences;
	}
	
	public String[] splitToTokens(String text){

	    String tokens[] = tokenDetector.tokenize(text);	  
	    
	    return tokens;
}


	public void splitToChunks(String text){
		
	}

	public void splitToClauses(String text){
		
	}

	
	public static String applyServiceToText(String text, int service) {
		
		if (text.equals("")) return "";
		
		
    	String URL = "http://dcl.bas.bg/dclservices/service/bglpc/"
    			+ services[service] + "/text/";
    	
    	System.out.println(URL);
    	
    	HttpClient httpclient = new DefaultHttpClient();
    	
    	try {
    			                
  /**
    		List<Cookie> cookies = ((AbstractHttpClient) httpclient).getCookieStore().getCookies();
          if (cookies.isEmpty()) {

          } else {

        	  for (int i = 0; i < cookies.size(); i++) {

		                    
        	  }
    			                
          }
    */			       
    		
			

    		List<NameValuePair> formparams = new ArrayList<NameValuePair>();

    		formparams.add(new BasicNameValuePair("text", text));
       		formparams.add(new BasicNameValuePair("token", token));
     		formparams.add(new BasicNameValuePair("submit", "submit"));
    		
    		UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
    		
    		HttpPost httppost = new HttpPost();
    		httppost.setEntity(entity);
    		httppost.setURI(new URI(URL));
    		

    		HttpResponse response = httpclient.execute(httppost);

    		HttpEntity myEntity = response.getEntity();
     		
    		String result = EntityUtils.toString(myEntity);
  
    		httppost.abort();
    		
    		
    		return result;
    		
    	} catch(Exception e)  {
    		e.printStackTrace();

    	}
    			            
    	return null;
	}
	
	public static String getTextAsLemmaSequence(String text) {
		String result = "";
		
		String tagged = applyServiceToText(text, Lematizer);
		
		try{
		
 		InputStream is = new ByteArrayInputStream(tagged.getBytes());
		 
		// read it with BufferedReader
		BufferedReader br = new BufferedReader(new InputStreamReader(is));

        String line;
  		while ((line = br.readLine().trim()) != null) {
  			if (line.equals("")) continue;
  			
  			String[] elements = line.split("\t");
  			if (elements.length<3) continue;
  			if (elements[2].trim().equals("U")) continue;
  			
  			result += elements[1] + " ";
  			
  			
  		}
		} catch(Exception e){
			e.printStackTrace();
		}
		
		return result;
	}
	
	public int getNumberOfWords (File f) {

		int result = 0;

		try{
		
			Scanner s = new Scanner(f);
			
			while (s.hasNextLine()) {
				String l = s.nextLine();
				
				String[] data = l.split("[ \t,\\.]");
				for (String w : data) if (!w.equals("")) result ++;
			}
		
			s.close();
			
		} catch(Exception e){
			e.printStackTrace();
		}
		
		return result;
	}
	public boolean checkSentenceSuitableForTranslation(String sent){
		boolean result = true;
		if (sent.length() < 60) result = false;
		if (sent.length() > 800) result = false;
		
		int ctr_letters = 0;
		for (int i=0; i<sent.length(); i++) {
			
			if (Character.isLetter(sent.charAt(i))) ctr_letters++;
			
			
		}
		
		if (1.0*ctr_letters/sent.length() < 0.7) result = false;
		
		
		if (result) System.out.println("SENT is OK: " + sent);
		else System.out.println("SENT is NOT OK: " + sent);
			
		return result;
		
	}
	
	public double[] getSimilarityCyrillicAndLatin(String cyr, String lat){
		
		// result[0] - % of lat symbols with correspondence in cyr
		// result[1] - % of cyr symbols with correspondence in lat
		double[] result = new double[]{0.0, 0.0};
		
		cyr = cyr.toLowerCase();
		lat = lat.toLowerCase();
		
		int cyrlen = cyr.length();
		int latlen = lat.length();
		
		HashMap<String,String[]> map = new HashMap<String,String[]>();
		map.put("a", new String[]{"а","я"});
		map.put("b", new String[]{"б"});
		map.put("c", new String[]{"ц","с","к"});
		map.put("d", new String[]{"д"});
		map.put("e", new String[]{"е","и"});
		map.put("f", new String[]{"ф"});
		map.put("g", new String[]{"г","дж","ж"});
		map.put("h", new String[]{"х"});
		map.put("i", new String[]{"и","ай"});
		map.put("j", new String[]{"й","дж","ж"});
		map.put("k", new String[]{"к"});
		map.put("l", new String[]{"л"});
		map.put("m", new String[]{"м"});
		map.put("n", new String[]{"н"});
		map.put("o", new String[]{"о","оу"});
		map.put("p", new String[]{"п"});
		map.put("q", new String[]{"к"});
		map.put("r", new String[]{"р"});
		map.put("s", new String[]{"с","ш"});
		map.put("t", new String[]{"т"});
		map.put("u", new String[]{"у","ю"});
		map.put("v", new String[]{"в"});
		map.put("w", new String[]{"у","в"});
		map.put("x", new String[]{"кс"});
		map.put("y", new String[]{"и","ъ","й", "ь"});
		map.put("z", new String[]{"з"});
		map.put("ł", new String[]{"з"});
		map.put("ż", new String[]{"ж","з"});
		map.put("ń", new String[]{"н"});
		map.put("ó", new String[]{"о"});
		map.put("ę", new String[]{"е"});
		map.put("ö", new String[]{"о"});
		map.put("Ś".toLowerCase(), new String[]{"с","ш"});
			
		
			
		for (int i = 0; i < lat.length(); i++) {
			String l  = lat.substring(i, i+1);
			
			if (cyr.contains(l)) {
				result[0] += 1.0/latlen;
				cyr = cyr.replaceFirst(l, "");
				continue;
			} 

			if (map.containsKey(l)) {
				String[] cor = map.get(l);
				
				for (String s : cor){
					if (cyr.contains(s)) {
						result[0] += 1.0/latlen;
						cyr = cyr.replaceFirst(s, "");
						break;
					}
				}
				continue;
			}
		}
		
		result[1] = 1.0 - 1.0*cyr.length()/cyrlen;
			
		return result;
		
	}


	public void processDir(String inputDir, String outputDir, boolean skipExisting){
		
		FileHandler fh = new FileHandler(); 
		
		try{
			
			List<File> list = fh.getFileListing(new File(inputDir));
			
			for (File f : list) {
				
				if (!f.isFile()) continue;
				
				String outFile = f.getAbsolutePath().replace(inputDir,  outputDir);
				
				fh.makeParent(outFile, "/");
				
				System.out.println(f.getAbsolutePath());
				
				if (skipExisting && new File(outFile).exists()) continue;
				
				Writer wr = new OutputStreamWriter(new FileOutputStream(outFile),"UTF-8");

				Scanner s = new Scanner(f);
				
				
				String allines = "";
				while(s.hasNextLine()){
					String line = s.nextLine();
					allines += line + "\n";
					

					if (allines.length()>10000 || !s.hasNextLine()){
						
						
						String taggedline = applyServiceToText(allines, 2);
						
						wr.write(taggedline+"\n");
						wr.flush();

						
						allines = "";
					}

				}
				
				
				wr.flush();
				wr.close();
				
				s.close();
			}
			
			
		} catch(Exception e){
			e.printStackTrace();
		}
		
		
	}


}

