package bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser;

import java.io.File;
import java.util.ArrayList;
import java.util.Scanner;

import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.Token;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.entities.Word;

public class VerbFormFormalism extends ArrayList<VerbFormModel>{
	
	public int n = 2;
	
	ArrayList<String> posAndLemmaTriggers = new ArrayList<String>();
	
	public void readModelsFromFile(String f){
		
		try{
			
			Scanner s = new Scanner(new File(f));
			
			while (s.hasNextLine()){
				
				String l = s.nextLine().trim();
				
				if (l.trim().equals("")) continue;
				
//				System.out.println(l);
				
				VerbFormModel vf = new VerbFormModel();
				vf.readVerbFormModelFromString(l, n);
				
				if (vf.size() > 0) {
					
					VerbComponent vc = vf.get(0);
					String trigger = vc.lemma;
					if (trigger.equals("")) trigger = vc.pos.substring(0,1);
						
					if (!trigger.equals("")
							&& !posAndLemmaTriggers.contains(trigger)) 
						posAndLemmaTriggers.add(trigger);
					
					int position = 0;
					for (int i=0; i<this.size(); i++){
						
						if (get(i).getFormModelLen() <= vf.getFormModelLen()) {
							position=i;
							break;
						}
					}
					add(position,vf);
				}
				
				
			}
			
//			System.out.println(this.size());
			s.close();
		} catch(Exception e){
			e.printStackTrace();
		}
		
		
	}


	public ArrayList<VerbForm> findForms(Sentence sent) {
		
		ArrayList<VerbForm> verbs = new ArrayList<VerbForm>();
		
		int start = 0;
		
		while (start<sent.size()) {
			
			Word t = sent.get(start);
			
//			System.out.println("CHECK: "+t.lemma+" "+t.posTag);
			if (!posAndLemmaTriggers.contains(t.lemma)
					&& t.pos.length()>0
					&& !posAndLemmaTriggers.contains(
							t.pos.substring(0,1))) {
				
				start++;
				continue;
			}
			

			
//			System.out.println("Trigger: "+t.lemma+"\t"+t.posTag);
			
			int modellen = 0;
			VerbForm currentform = new VerbForm();
			
			for (VerbFormModel vfm : this){
				
				if (vfm.getFormModelLen() < modellen) break;
				
				/**
				if (vfm.size()==1 && vfm.get(0).pos.equals("V") 
						&& vfm.get(0).lemma.equals("") 
						&& vfm.get(0).gram.equals("")){
					if (t.posTag.equals("V")) {
						
						if (verbs.size() == 0){
							VerbForm form = new VerbForm();
							form.add(start);
							verbs.add(form);
						} else {
							continue;
						}
					}
				}
				 */

				VerbForm form = vfm.findMatch(sent, start);
//				System.out.println(form.mainword.lemma);
				
				if (form != null && form.size()>0) {
					
					form.tense.add(vfm.tense);

					if (currentform.size()>0) {
						currentform.tense.add(vfm.tense);
						continue;
					} else {
						currentform = form;
					}
					
//					System.out.println("Form: "+form.size());
					
					modellen = vfm.getFormModelLen();
				}
			}

			if (currentform.size() > 0) {		
				if (currentform.size() == 1
						&& currentform.tense.size()>1
						&& currentform.tense.contains("Infinitive")){
					currentform.tense.remove("Infinitive");
				}
				
				verbs.add(currentform);
				start = currentform.get(currentform.size()-1).sentpos;
			}
			
			start++;
		
		}
		
		return verbs;
	}
}
