package bg.bas.dcl.multilingual.ClauseSplitting.rules;

import java.util.ArrayList;
import java.util.HashMap;

import bg.bas.dcl.entities.ClauseConjunction;
import bg.bas.dcl.entities.Conjunction;
import bg.bas.dcl.entities.Sentence;
import bg.bas.dcl.entities.VerbForm;
import bg.bas.dcl.multilingual.Chunker.VerbFormRecogniser.ClauseVerb;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseBorder;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseSplittingComplexObject;
import bg.bas.dcl.multilingual.ClauseSplitting.ClauseStack;

public class ConjunctionClauseSplittingRule implements ClauseSplittingRule {
	
	public boolean isEndingRule = true;
	
	ArrayList<Conjunction> conjList = new ArrayList<Conjunction>();
	ArrayList<String> specAdverbs = new ArrayList<String>();
		
	public ConjunctionClauseSplittingRule (
			ArrayList<Conjunction> conjList,
			ArrayList<String> spAdv) {
		this.conjList = conjList;
		this.specAdverbs = spAdv;
		
		System.out.println(conjList.size());

	}

	public ClauseSplittingComplexObject findClauseBorders(
			Sentence sentence,
			ArrayList<ClauseVerb> verbs, 
			int spos, int epos,
			ClauseStack stack
			){
		
		ClauseSplittingComplexObject obj = new ClauseSplittingComplexObject();
		obj.cls = stack;
		obj.clborders = new ArrayList<ClauseBorder>();
		obj.clconjunctions = new ArrayList<ClauseConjunction>();
				
		if (obj.cls.stackSize()>0 && obj.cls.getTypeFromStack(1).equals("SCOC")){
			spos = Math.max(obj.cls.getIndexFromStack(1),spos);
		}
		
		if (obj.cls.stackSize()>0 && spos < obj.cls.getIndexFromStack(1)) {
			spos = obj.cls.getIndexFromStack(1);
		}
		
		for (int i=spos; i<epos+1; i++) {
			
					
cl:			for (Conjunction c : conjList){
	
				
				if (!c.isCompulsaryCO) continue;
				
				ClauseConjunction clcon = new ClauseConjunction();
				
				String[] parts = c.lemma.split(" ");
				
				for (int k=0; k<parts.length; k++) {
					if (i+k<sentence.size() && 
							!parts[k].equalsIgnoreCase(sentence.get(i+k).lemma)){
						continue cl;
					}
					clcon.add(i+k);

				}
				
				System.out.println(c.lemma);
				int pos = i;
				int nextpos = pos + parts.length - 1;
				
				
				if (i>0 && specAdverbs.contains(sentence.get(i-1).lemma)) {					
						pos = i-1;
				} else if (c.preceedingCommaCO) {
					for (int p = i-1; p > Math.max(
							Math.max(obj.cls.size()>0?obj.cls.getIndexFromStack(1):-1,spos), i-4); p--) {

						if (isConj(sentence.get(p).lemma)) {
							
							break;
						}
						
						if (sentence.get(p).wordform.equals(",")) {
							
							pos = p+1;
							break;
						}
					}
				}
				
				/**
				if (verbIsPresent(sentence, verbs, 
						obj.cls
							.getIndexFromStack(1),pos-1)){

					obj.clborders.add(new ClauseBorder(pos-1, "CC"));
					obj.cls.removeFromStack();
					
				}
				*/
				
				clcon.type = c.type;
				clcon.semanticType = c.semanticType;
				

				
				if (c.type.startsWith("C"))	{
					
					clcon.relation = "N_N";
					clcon.cl2_ind = obj.cls.getIndexFromStack(1);

					obj.clborders.add(new ClauseBorder(pos, "COC"));
					obj.cls.putInStack("COC", pos);
					
					
				}
				
				if (c.type.startsWith("S"))	{
					

					if (obj.cls.size()>0) {
						
						if (obj.cls.getIndexFromStack(1) < pos) {
							clcon.relation = "N_S";
							clcon.cl2_ind = obj.cls.getIndexFromStack(1);
						}
						
						if (obj.cls.getIndexFromStack(1) == pos) {
							clcon.relation = "_SN";
							
						}
						

					}

					
					obj.clborders.add(new ClauseBorder(pos, "COS"));
					obj.cls.putInStack("COS", pos);
				}
			
				for (int k = clcon.get(0)-1; k>pos-1; k--) clcon.add(0,k);
				
				obj.clconjunctions.add(clcon);

				i = nextpos;
				break;

			}
		}
		
		return obj;
		
	}
	
	public boolean isConj(String conj){
		
		for (Conjunction cc : conjList){
			if (cc.lemma.equals(conj)) return true;
		}
		return false;
	}
	
	public boolean isEnding(){
		return isEndingRule;
	}

	public boolean verbIsPresent(Sentence sent, 
			ArrayList<ClauseVerb> verbs, int begin, int end){
		
		
		
		int vind = -1;
		for (VerbForm vf : verbs) {
			if (begin <= vf.get(0).sentpos && vf.get(vf.size()-1).sentpos <= end
					&& sent.get(vf.get(0).sentpos).clauseID.equals(sent.get(begin).clauseID)) {
		
//				System.out.println("VC: begin "+begin + " end "+end);
//				System.out.println("VC: "+sent.get(vf.get(0)).wordform + " "+sent.get(vf.get(0)).clauseID);
//				System.out.println("VC: "+sent.get(begin).wordform + " "+sent.get(begin).clauseID);
				vind = vf.get(vf.size()-1).sentpos;
				break;
			}
		}
		
		if (vind > -1 && vind < end) return true;
		
		return false;
	}


}
