package bg.bas.dcl.semantic.lexical_db;

import java.util.ArrayList;

import org.apache.commons.lang3.StringEscapeUtils;

public class Synset {
	
	public String ID = "";
	public String pos = "";
	public String definition = "";
	
	public String status = "";
	public String semclass = "";
	
	public ArrayList<Literal> literals = new ArrayList<Literal>();
	public ArrayList<Relation> relations = new ArrayList<Relation>();

	public ArrayList<String> usages = new ArrayList<String>();

	
	public String printLiterals(){
		
		String result = "";
		
		for (Literal l : literals) result += l.lemma + "; ";
		
		return result;
	}
	
	public String toXML(){
		
		String result = "<SYNSET>";
		
		result += "<ID>" + ID + "</ID>";
		result += "<POS>" + pos + "</POS>";
		result += "<SEM_CLASS>" + semclass + "</SEM_CLASS>";

		result += "<SYNONYM>";
		
		for (Literal l : literals) {
			result += l.toXML();
		}
		
		result += "</SYNONYM>";

		
		for (Relation r : relations) {
			result += r.toXML();
		}
		
		

		for (String u : usages)	result += "<USAGE>" + StringEscapeUtils.escapeXml(u) + "</USAGE>";

		if (definition.length()>0) result += "<DEF>" + StringEscapeUtils.escapeXml(definition) + "</DEF>";
		if (status.length()>0) result += "<STATUS>" + StringEscapeUtils.escapeXml(status) + "</STATUS>";


		result += "</SYNSET>";
		

		return result;

		
	}
	
	public String getRelation(String name) {
		for (Relation r : relations) {
			if (r.type.equalsIgnoreCase(name)) return r.sem;
		}
		return null;
	}
	public String getHypernymID() {
		for (Relation r : relations) {
			if (r.type.equalsIgnoreCase("hypernym")) return r.ID;
		}
		return null;
	}
	
	
}
